﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Olap;
using Infragistics.Olap.Model;
using Infragistics.Olap.Model.Base;

namespace Explorer.Core
{
    public class SimpleViewModel: IOlapViewModel
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public event EventHandler<AsyncCompletedEventArgs> LoadCubesCompleted;
        public event EventHandler<AsyncCompletedEventArgs> LoadMeasuresCompleted;
        public event EventHandler<AsyncCompletedEventArgs> LoadDimensionsCompleted;
        public event EventHandler ResultChanged;

        public void LoadCubesAsync()
        {
            if(LoadCubesCompleted != null)
            {
                LoadCubesCompleted(this, new AsyncCompletedEventArgs(null, false, null));
            }
        }

       

        public void FillMembers(ILevel level)
        {
            throw new System.NotImplementedException();
        }

        public void FillMembers(IMember member)
        {
            throw new System.NotImplementedException();
        }

        public void SwitchAxisMember(IMember axisMember)
        {
            throw new System.NotImplementedException();
        }

        public void RefreshGrid()
        {
            throw new System.NotImplementedException();
        }

        public void PivotGrid()
        {
            throw new System.NotImplementedException();
        }

        public IFilterViewModel CreateFilterViewModel(IHierarchy hierarchy)
        {
            throw new System.NotImplementedException();
        }

        public IMeasureViewModel CreateMeasureViewModel(IMeasure measure)
        {
            throw new System.NotImplementedException();
        }

        public ObservableCollection<ICube> Cubes
        {
            get { throw new System.NotImplementedException(); }
        }

        public ICube SelectedCube
        {
            get { throw new System.NotImplementedException(); }
            set { throw new System.NotImplementedException(); }
        }

        public ObservableCollection<IDimension> Dimensions
        {
            get { throw new System.NotImplementedException(); }
        }

        public ObservableCollection<IMeasure> Measures
        {
            get { throw new System.NotImplementedException(); }
        }

        public SwapCollection<IFilterViewModel> Columns
        {
            get { throw new System.NotImplementedException(); }
        }

        public SwapCollection<IFilterViewModel> Rows
        {
            get { throw new System.NotImplementedException(); }
        }

        public SwapCollection<IMeasureViewModel> SelectedMeasures
        {
            get { throw new System.NotImplementedException(); }
        }

        public SwapCollection<IFilterViewModel> Filters
        {
            get { throw new System.NotImplementedException(); }
        }

        public IResult Result
        {
            get
            {
                SimpleMember col_1 = new SimpleMember("SalesEURO", "SalesEURO", "Sales, EURO", "", "topcol", 0, 0);
                List<IMember> colmem = new List<IMember>();
                colmem.Add(col_1);
                SimpleTuple t = new SimpleTuple(new ReadOnlyCollection<IMember>(colmem));
               
                List<ITuple> coltup = new List<ITuple>();
                coltup.Add(t);
                SimpleResultAxis cols = new SimpleResultAxis(coltup);

                SimpleMember row_1 = new SimpleMember("A1", "A1", "Europe", "", "toprow", 0, 0);

                List<IMember> rowmem = new List<IMember>();
                rowmem.Add(row_1);
                SimpleTuple t2 = new SimpleTuple(new ReadOnlyCollection<IMember>(rowmem));
                List<ITuple> rowtup = new List<ITuple>();
                rowtup.Add(t2);
                SimpleResultAxis rows = new SimpleResultAxis(rowtup);

                SimpleCell[,] cells = new SimpleCell[1, 1];
                cells[0, 0] = new SimpleCell {value = "1", formattedValue = "1"};

                return new SimpleResult {cells = cells, columnAxis = cols, rowAxis = rows};
            }
        }

        public IModelProvider ModelProvider
        {
            get { throw new System.NotImplementedException(); }
        }

        public bool ParentInFront
        {
            get; set;
        }

        public bool DeferredLayoutUpdate
        {
            get;
            set;
        }

        public void Update()
        {
            if(ResultChanged != null)
            {
                ResultChanged(this, EventArgs.Empty);
            }
        }
    }

    public class SimpleMember: IMember
    {
        private string _name;

        private string _uniqueName;

        private string _caption;

        private string _parentUniqueName;

        private string _levelName;

        private int _levelDepth;

        private int _childCount;

        private ReadOnlyCollection<IMember> _members;


        public SimpleMember(string text): this(text, text, text, "", "", 0, 0)
        {            
        }

        public SimpleMember(string name, string uniqueName, string caption, string parentUniqueName, string levelName, int depth, int childcount)
        {
            _name = name;
            _uniqueName = uniqueName;
            _caption = caption;
            _parentUniqueName = parentUniqueName;
            _levelName = levelName;
            _levelDepth = depth;
            _childCount = childcount;
            _members = new ReadOnlyCollection<IMember>(new List<IMember>());
        }

        public string Name
        {
            get { return _name; }
        }

        public string UniqueName
        {
            get { return _uniqueName; }
        }

        public string Caption
        {
            get { return _caption; }
        }

        public string ParentUniqueName
        {
            get { return _parentUniqueName; }
        }

        public string LevelName
        {
            get { return _levelName; }
        }

        public int LevelDepth
        {
            get { return _levelDepth; }
        }

        public int ChildCount
        {
            get { return _childCount; }
        }

        public ReadOnlyCollection<IMember> Members
        {
            get { return _members; }
        }
    }

    public class SimpleTuple: ITuple
    {
        internal ReadOnlyCollection<IMember> _members = new ReadOnlyCollection<IMember>(new List<IMember>());

        public SimpleTuple(ReadOnlyCollection<IMember> m)
        {
            _members = m;
        }

        public SimpleTuple(List<IMember> m)
        {
            _members = new ReadOnlyCollection<IMember>(m);
        }

        public static SimpleTuple WithAll(params IMember[] p)
        {
            return new SimpleTuple(new ReadOnlyCollection<IMember>(new List<IMember>(p)));
        }

        public static SimpleTuple Empty()
        {
            return new SimpleTuple(new ReadOnlyCollection<IMember>(new List<IMember>()));
        }

        public ReadOnlyCollection<IMember> Members
        {
            get
            {
                return _members;
            }
        }
    }

    public class SimpleResultAxis: IResultAxis
    {
        private ReadOnlyCollection<ITuple> _tuples;

        public SimpleResultAxis(IList<ITuple> tpl)
        {
            _tuples = new ReadOnlyCollection<ITuple>(tpl);
        }

        public ReadOnlyCollection<ITuple> Tuples
        {
            get { return _tuples; }
        }
    }

    public class SimpleCell: ICell
    {
        public object value;

        public string formattedValue;

        public object Value
        {
            get { return value; }
        }

        public string FormattedValue
        {
            get { return formattedValue; }
        }
    }

    public class SimpleResult: IResult
    {
        public IResultAxis rowAxis;

        public IResultAxis columnAxis;

        public ICell[,] cells;

        public IResultAxis RowAxis
        {
            get { return rowAxis; }
        }

        public IResultAxis ColumnAxis
        {
            get { return columnAxis; }
        }

        public ICell[,] Cells
        {
            get { return cells; }
        }
    }
}
